package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.Objects;

/**
 * UpdateSsidBasicConfigOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class UpdateSsidBasicConfigOpenApiVo   {
  @JsonProperty("name")
  private String name;

  @JsonProperty("band")
  private Integer band;

  @JsonProperty("guestNetEnable")
  private Boolean guestNetEnable;

  @JsonProperty("security")
  private Integer security;

  @JsonProperty("broadcast")
  private Boolean broadcast;

  @JsonProperty("vlanEnable")
  private Boolean vlanEnable;

  @JsonProperty("vlanId")
  private Integer vlanId;

  @JsonProperty("pskSetting")
  private Object pskSetting;

  @JsonProperty("entSetting")
  private Object entSetting;

  @JsonProperty("ppskSetting")
  private Object ppskSetting;

  @JsonProperty("mloEnable")
  private Boolean mloEnable;

  @JsonProperty("pmfMode")
  private Integer pmfMode;

  @JsonProperty("enable11r")
  private Boolean enable11r;

  @JsonProperty("hidePwd")
  private Boolean hidePwd;

  @JsonProperty("greEnable")
  private Boolean greEnable;

  public UpdateSsidBasicConfigOpenApiVo name(String name) {
    this.name = name;
    return this;
  }

  /**
   * SSID name. It should contain 1 to 32 UTF-8 characters.
   * @return name
  */
  @ApiModelProperty(required = true, value = "SSID name. It should contain 1 to 32 UTF-8 characters.")
  @NotNull


  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public UpdateSsidBasicConfigOpenApiVo band(Integer band) {
    this.band = band;
    return this;
  }

  /**
   * SSID band. The lowest bit indicates whether 2.4G is included; the second lowest bit indicates whether 5G is included; the third lowest bit indicates whether 6G is included; 1 means included while 0 means not included. For example, 7(111) means that 2G/5G/6G are enabled; 1(001) means that 2G is enabled. (When 5G is included，it means 5G/5G1/5G2 are enabled.)
   * @return band
  */
  @ApiModelProperty(required = true, value = "SSID band. The lowest bit indicates whether 2.4G is included; the second lowest bit indicates whether 5G is included; the third lowest bit indicates whether 6G is included; 1 means included while 0 means not included. For example, 7(111) means that 2G/5G/6G are enabled; 1(001) means that 2G is enabled. (When 5G is included，it means 5G/5G1/5G2 are enabled.)")
  @NotNull


  public Integer getBand() {
    return band;
  }

  public void setBand(Integer band) {
    this.band = band;
  }

  public UpdateSsidBasicConfigOpenApiVo guestNetEnable(Boolean guestNetEnable) {
    this.guestNetEnable = guestNetEnable;
    return this;
  }

  /**
   * SSID guest network config status. True: enable, false: disable.
   * @return guestNetEnable
  */
  @ApiModelProperty(required = true, value = "SSID guest network config status. True: enable, false: disable.")
  @NotNull


  public Boolean getGuestNetEnable() {
    return guestNetEnable;
  }

  public void setGuestNetEnable(Boolean guestNetEnable) {
    this.guestNetEnable = guestNetEnable;
  }

  public UpdateSsidBasicConfigOpenApiVo security(Integer security) {
    this.security = security;
    return this;
  }

  /**
   * SSID security mode; Security should be a value as follows: 0: None; 2: WPA-Enterprise; 3: WPA-Personal; 4: PPSK without RADIUS; 5: PPSK with RADIUS.
   * @return security
  */
  @ApiModelProperty(required = true, value = "SSID security mode; Security should be a value as follows: 0: None; 2: WPA-Enterprise; 3: WPA-Personal; 4: PPSK without RADIUS; 5: PPSK with RADIUS.")
  @NotNull


  public Integer getSecurity() {
    return security;
  }

  public void setSecurity(Integer security) {
    this.security = security;
  }

  public UpdateSsidBasicConfigOpenApiVo broadcast(Boolean broadcast) {
    this.broadcast = broadcast;
    return this;
  }

  /**
   * SSID broadcast config status. True: enable, false: disable.
   * @return broadcast
  */
  @ApiModelProperty(required = true, value = "SSID broadcast config status. True: enable, false: disable.")
  @NotNull


  public Boolean getBroadcast() {
    return broadcast;
  }

  public void setBroadcast(Boolean broadcast) {
    this.broadcast = broadcast;
  }

  public UpdateSsidBasicConfigOpenApiVo vlanEnable(Boolean vlanEnable) {
    this.vlanEnable = vlanEnable;
    return this;
  }

  /**
   * SSID VLAN config status. True: enable, false: disable.
   * @return vlanEnable
  */
  @ApiModelProperty(required = true, value = "SSID VLAN config status. True: enable, false: disable.")
  @NotNull


  public Boolean getVlanEnable() {
    return vlanEnable;
  }

  public void setVlanEnable(Boolean vlanEnable) {
    this.vlanEnable = vlanEnable;
  }

  public UpdateSsidBasicConfigOpenApiVo vlanId(Integer vlanId) {
    this.vlanId = vlanId;
    return this;
  }

  /**
   * SSID VLAN ID. This field is required when Parameter [vlanEnable] is true; It should be within the range of 1–4094.
   * @return vlanId
  */
  @ApiModelProperty(value = "SSID VLAN ID. This field is required when Parameter [vlanEnable] is true; It should be within the range of 1–4094.")


  public Integer getVlanId() {
    return vlanId;
  }

  public void setVlanId(Integer vlanId) {
    this.vlanId = vlanId;
  }

  public UpdateSsidBasicConfigOpenApiVo pskSetting(Object pskSetting) {
    this.pskSetting = pskSetting;
    return this;
  }

  /**
   * Get pskSetting
   * @return pskSetting
  */
  @ApiModelProperty(value = "")

  @Valid

  public Object getPskSetting() {
    return pskSetting;
  }

  public void setPskSetting(Object pskSetting) {
    this.pskSetting = pskSetting;
  }

  public UpdateSsidBasicConfigOpenApiVo entSetting(Object entSetting) {
    this.entSetting = entSetting;
    return this;
  }

  /**
   * Get entSetting
   * @return entSetting
  */
  @ApiModelProperty(value = "")

  @Valid

  public Object getEntSetting() {
    return entSetting;
  }

  public void setEntSetting(Object entSetting) {
    this.entSetting = entSetting;
  }

  public UpdateSsidBasicConfigOpenApiVo ppskSetting(Object ppskSetting) {
    this.ppskSetting = ppskSetting;
    return this;
  }

  /**
   * Get ppskSetting
   * @return ppskSetting
  */
  @ApiModelProperty(value = "")

  @Valid

  public Object getPpskSetting() {
    return ppskSetting;
  }

  public void setPpskSetting(Object ppskSetting) {
    this.ppskSetting = ppskSetting;
  }

  public UpdateSsidBasicConfigOpenApiVo mloEnable(Boolean mloEnable) {
    this.mloEnable = mloEnable;
    return this;
  }

  /**
   * SSID MLO config status. True: enable, false: disable.
   * @return mloEnable
  */
  @ApiModelProperty(required = true, value = "SSID MLO config status. True: enable, false: disable.")
  @NotNull


  public Boolean getMloEnable() {
    return mloEnable;
  }

  public void setMloEnable(Boolean mloEnable) {
    this.mloEnable = mloEnable;
  }

  public UpdateSsidBasicConfigOpenApiVo pmfMode(Integer pmfMode) {
    this.pmfMode = pmfMode;
    return this;
  }

  /**
   * SSID PMF mode. It should be a value as follows: 1: Mandatory; 2: Capable; 3: Disable.
   * @return pmfMode
  */
  @ApiModelProperty(required = true, value = "SSID PMF mode. It should be a value as follows: 1: Mandatory; 2: Capable; 3: Disable.")
  @NotNull


  public Integer getPmfMode() {
    return pmfMode;
  }

  public void setPmfMode(Integer pmfMode) {
    this.pmfMode = pmfMode;
  }

  public UpdateSsidBasicConfigOpenApiVo enable11r(Boolean enable11r) {
    this.enable11r = enable11r;
    return this;
  }

  /**
   * SSID 802.11r config status. True: enable, false: disable.
   * @return enable11r
  */
  @ApiModelProperty(required = true, value = "SSID 802.11r config status. True: enable, false: disable.")
  @NotNull


  public Boolean getEnable11r() {
    return enable11r;
  }

  public void setEnable11r(Boolean enable11r) {
    this.enable11r = enable11r;
  }

  public UpdateSsidBasicConfigOpenApiVo hidePwd(Boolean hidePwd) {
    this.hidePwd = hidePwd;
    return this;
  }

  /**
   * If this field is true, the SSID password will be hidden.
   * @return hidePwd
  */
  @ApiModelProperty(required = true, value = "If this field is true, the SSID password will be hidden.")
  @NotNull


  public Boolean getHidePwd() {
    return hidePwd;
  }

  public void setHidePwd(Boolean hidePwd) {
    this.hidePwd = hidePwd;
  }

  public UpdateSsidBasicConfigOpenApiVo greEnable(Boolean greEnable) {
    this.greEnable = greEnable;
    return this;
  }

  /**
   * SSID EoGre Tunnel config status. True: enable, false: disable; This configuration can be enabled only when the [VPN - EoGre Tunnel] global config is enabled(This configuration applies to the Pro Site of the Omada Pro Controller only).
   * @return greEnable
  */
  @ApiModelProperty(required = true, value = "SSID EoGre Tunnel config status. True: enable, false: disable; This configuration can be enabled only when the [VPN - EoGre Tunnel] global config is enabled(This configuration applies to the Pro Site of the Omada Pro Controller only).")
  @NotNull


  public Boolean getGreEnable() {
    return greEnable;
  }

  public void setGreEnable(Boolean greEnable) {
    this.greEnable = greEnable;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UpdateSsidBasicConfigOpenApiVo updateSsidBasicConfigOpenApiVo = (UpdateSsidBasicConfigOpenApiVo) o;
    return Objects.equals(this.name, updateSsidBasicConfigOpenApiVo.name) &&
        Objects.equals(this.band, updateSsidBasicConfigOpenApiVo.band) &&
        Objects.equals(this.guestNetEnable, updateSsidBasicConfigOpenApiVo.guestNetEnable) &&
        Objects.equals(this.security, updateSsidBasicConfigOpenApiVo.security) &&
        Objects.equals(this.broadcast, updateSsidBasicConfigOpenApiVo.broadcast) &&
        Objects.equals(this.vlanEnable, updateSsidBasicConfigOpenApiVo.vlanEnable) &&
        Objects.equals(this.vlanId, updateSsidBasicConfigOpenApiVo.vlanId) &&
        Objects.equals(this.pskSetting, updateSsidBasicConfigOpenApiVo.pskSetting) &&
        Objects.equals(this.entSetting, updateSsidBasicConfigOpenApiVo.entSetting) &&
        Objects.equals(this.ppskSetting, updateSsidBasicConfigOpenApiVo.ppskSetting) &&
        Objects.equals(this.mloEnable, updateSsidBasicConfigOpenApiVo.mloEnable) &&
        Objects.equals(this.pmfMode, updateSsidBasicConfigOpenApiVo.pmfMode) &&
        Objects.equals(this.enable11r, updateSsidBasicConfigOpenApiVo.enable11r) &&
        Objects.equals(this.hidePwd, updateSsidBasicConfigOpenApiVo.hidePwd) &&
        Objects.equals(this.greEnable, updateSsidBasicConfigOpenApiVo.greEnable);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, band, guestNetEnable, security, broadcast, vlanEnable, vlanId, pskSetting, entSetting, ppskSetting, mloEnable, pmfMode, enable11r, hidePwd, greEnable);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UpdateSsidBasicConfigOpenApiVo {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    band: ").append(toIndentedString(band)).append("\n");
    sb.append("    guestNetEnable: ").append(toIndentedString(guestNetEnable)).append("\n");
    sb.append("    security: ").append(toIndentedString(security)).append("\n");
    sb.append("    broadcast: ").append(toIndentedString(broadcast)).append("\n");
    sb.append("    vlanEnable: ").append(toIndentedString(vlanEnable)).append("\n");
    sb.append("    vlanId: ").append(toIndentedString(vlanId)).append("\n");
    sb.append("    pskSetting: ").append(toIndentedString(pskSetting)).append("\n");
    sb.append("    entSetting: ").append(toIndentedString(entSetting)).append("\n");
    sb.append("    ppskSetting: ").append(toIndentedString(ppskSetting)).append("\n");
    sb.append("    mloEnable: ").append(toIndentedString(mloEnable)).append("\n");
    sb.append("    pmfMode: ").append(toIndentedString(pmfMode)).append("\n");
    sb.append("    enable11r: ").append(toIndentedString(enable11r)).append("\n");
    sb.append("    hidePwd: ").append(toIndentedString(hidePwd)).append("\n");
    sb.append("    greEnable: ").append(toIndentedString(greEnable)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

